;a440 tuning pitch


#include "asm86.h"
#include "ti86asm.inc"

.org _asm_exec_ram
    nop
    jp PlayWAV      
    .dw 0
    .dw Title

Title:
.db "A440 tuner",0

PlayWAV:
 ld hl,Sound
 di                    ;greylib by robert taylor can't be used :(
 ld   a, 0C0h         
 out   (7), a
 ld   e, (hl)
 inc   hl
 ld   d, (hl)
 inc   hl
 ld   b, 128           ;b is used as a mask
SoundLoop:
 ld   c, 19
DLoop:
 dec   c
 jr nz,   DLoop
 nop
 rrc   b
 jr nc,   Play
 inc   hl               ;next byte
 dec   de
 ld   a, d
 or    e
 jr z,    PlayWAV
 xor   a                ;exit key pressed?
 out   (1), a
 in    a, (1)
 bit   6, a
 jr z,    DonePlay
Play:
 ld   a, (hl)          ;get bit
 and   b
 jr z,    Play1
 ld   a, 0FCh
 out   (7), a
 jr   SoundLoop
Play1:
 ld   a, 0C0h
 out   (7), a
 jr   SoundLoop
DonePlay:
 ld  a, 0C0h
 out  (7), a
 ei
 ret


;-----------------------------------------------------------------------------
;The WAV-File:
;-----------------------------------------------------------------------------
Sound:
 .dw 66

 .db $00,$3F,$FC,$00,$1F,$FE,$00,$0F,$FF,$00,$07,$FF,$80,$03,$FF,$C0
 .db $01,$FF,$E0,$00,$FF,$F0,$00,$7F,$F8,$00,$3F,$FE,$00,$1F,$FF,$00
 .db $0F,$FF,$80,$07,$FF,$C0,$03,$FF,$E0,$01,$FF,$F0,$00,$FF,$F8,$00
 .db $7F,$FC,$00,$3F,$FE,$00,$0F,$FF,$00,$07,$FF,$80,$03,$FF,$C0,$01
 .db $FF,$E0
.end
